#!/bin/bash

check_env() {
    [ -z "$1" ] && echo "$2 is not set" && exit 1
}

check_sanity() {
    [ ! -d "$1/$2" ] && echo "$1 isn't a valid path" && exit 1
}

override_dll() {
    wine reg add "HKEY_CURRENT_USER\Software\Wine\DllOverrides" /v $1 /d native /f
}

check_env "$WINEPREFIX" WINEPREFIX
check_sanity "$WINEPREFIX" drive_c

# User instructions:
# Set PROTON to a Proton folder just like WINEPREFIX, pass -proton to script
if [ "$1" = "-proton" ]; then

    check_env "$PROTON" PROTON
    check_sanity "$PROTON" dist/bin

    export PATH="$PROTON/dist/bin:$PATH"
    export WINESERVER="$PROTON/dist/bin/wineserver"
    export WINELOADER="$PROTON/dist/bin/wine"
    export WINEDLLPATH="$PROTON/dist/lib/wine:$PROTON/dist/lib64/wine"

fi

set -e
export WINEDEBUG="-all"

scriptdir="$(dirname "$(realpath "$0")")"
cd "$scriptdir"

cp -v syswow64/{d3d,dxgi,libvkd3d-proton-utils-2}*dll "$WINEPREFIX/drive_c/windows/syswow64"
cp -v system32/{d3d,dxgi,libvkd3d-proton-utils-2}*dll "$WINEPREFIX/drive_c/windows/system32"

override_dll "d3d10"
override_dll "d3d10_1"
override_dll "d3d10core"
override_dll "d3d11"
override_dll "d3d12"
override_dll "d3d9"
override_dll "dxgi"
override_dll "libvkd3d-proton-utils-2"
